function [Q,R] = myMGS(A,flag)
%function [Q,R] = myMGS(A,flag)
%Metodo de GRAM-SCHMIDT para la descomposicion QR
if nargin<2,flag=1;end
[m,n] = size(A);
Q=A;
r11=sqrt(Q(:,1)'*Q(:,1));Q(:,1)=Q(:,1)/r11;
R(1,1)=r11;
for k=1:n
    for i=1:(k-1)
        rik=Q(:,i)'*A(:,k);
        A(:,k)=A(:,k)-rik*Q(:,i);
        R(i,k)=rik;
    end
    qk=A(:,k);
    rkk=sqrt(qk'*qk);
    Q(:,k)=qk/rkk;
    R(k,k)=rkk;
end
%exit if flag is explicitly set to zero
if flag==0;return;end

%if m>n, we should invent something for the rest of the columns
k=n+1;
while k<=m
    dummy=rand(m,1);
    for i=1:(k-1)
        rik=Q(:,i)'*dummy;
        dummy=dummy-rik*Q(:,i);
    end
    qk=dummy;
    rkk=sqrt(qk'*qk);
    if rkk<eps
        %you are really unlucky! the random vector is collinear with all the previous
        %ones. But, do not worry! We can save your life doing nothing!
    else
        Q(:,k)=qk/rkk;
        k=k+1;
    end
end
R(m,n)=0;
