function [Q,R]=mygram(A,B,tol)   
%GRAM	Computes QR decomposition of A. 
% 	It uses the Gram-Schmidt algorithm. 
%	The inner product is given by <x,y>=x^tBy. 
%	If B is not given it is assigned to eye(m),
%	This just gives the usual dot product.
% 	The command is [Q,R]=GRAM(A,B,tol). 
%	tol is computed automatically if omitted.

%	Copyright 1993 Terry Lawson
%	Terry Lawson, Math Department, Tulane University, 11/93

[m,n]=size(A);
if (nargin < 2), B=eye(m); end
if (nargin < 3), tol = max([m,n])*eps*norm(A,'inf'); end
%Q(m,m) v(m,n) R(m,n) w(m,n) wtemp(m) t(m,n) nn(n)

%v=A;R=zeros(m,n);
for i=1:m,for j=1:n,v(i,j)=A(i,j);R(i,j)=0;end;end

k=1;
%w(:,1)=v(:,1);
for i=1:m,w(i,1)=A(i,1);end
%R(1,1)=sqrt(w(:,1)'*B*w(:,1));
sum=0;for i=1:m,sum=sum+w(i)*w(i);end;R(1,1)=sqrt(sum);

%Q(:,1)=w(:,1)/R(1,1);
Q=0;for i=1:m,Q(i,1)=w(i,1)/R(1,1);end

nn(1)=R(1,1);
for j= 2:n  
    %wtemp = v(:,j);
    for p=1:m,wtemp(p,1)=v(p,j);end
    
    for i= 1:k
        %t(i,j)=v(:,j)'*B*w(:,i)/(w(:,i)'*B*w(:,i));
        num=0;den=0;for p=1:m,num=num+v(p,j)*w(p,i);den=den+w(p,i)*w(p,i);end;t(i,j)=num/den;
        %wtemp = wtemp-t(i,j)*w(:,i);
        for p=1:m,wtemp(p)=wtemp(p)-t(i,j)*w(p,i);end
        R(i,j)=t(i,j)*nn(i);
    end                  
    %if sqrt(wtemp'*B*wtemp) > tol
    sum=0;for i=1:m,sum=sum+wtemp(i)*wtemp(i);end;
    if sqrt(sum)>tol
        k=k+1;
        %w(:,k)=wtemp;
        for p=1:m,w(p,k)=wtemp(p);end
        %nn(k)=sqrt(wtemp'*B*wtemp);
        sum=0;for i=1:m,sum=sum+wtemp(i)*wtemp(i);end;nn(k)=sqrt(sum);
        R(k,j)=nn(k);
        %Q(:,k)=w(:,k)/nn(k);
        for p=1:m,Q(p,k)=w(p,k)/nn(k);end
    end
end
%resize de la matriz
R=R(1:k,:);